{--- Draw a glass ball on the chessboard ---
 --- graphics mode: 640x480x256          ---
 --- BGI graphis used (SVGA256.BGI)      ---
 Original author unknown :(
 slightly changed for correct graphics closing
 by Valery Votintsev 2:5021/22 
}

program MINDPROBE;
uses graph,crt;
var 
  tt,a,i,k,o,p,s,c,v,b:longint;
  sr,sc,sv,sb,sd,ic,iv,ib,il,vc,vv,vb:extended;
  l,t,col,sch,ops:integer;
  d,g,h,j,x1,x2,y:real;
  f:double;
  ss:string;
  q:array[1..42100] of byte;
  key:char;
begin
  l:=installuserdriver('svga256',nil);
  t:=2;
  i:=4;
  initgraph(l,t,'');
  line(100,100,200,200);
  cleardevice;
  x1:=480;x2:=240;y:=720;
  c:=500;v:=800;b:=800;
  sr:=100;sc:=800;sv:=50;sb:=200;
  for i:=1 to 63 do
    setrgbpalette(i,i,i,i);
  for i:=0 to 240 do
    for k:=1 to 640 do begin
      a:=trunc(sqrt(sqr(520-120)+sqr(720+(720*((260-i)/(i+20))))));
      s:=trunc(((k-320)/720)*a);
      f:=sqrt(a*a+s*s/4);
      a:=trunc(f);
      col:=trunc(63*b/sqrt(sqr(a-c)+sqr(s-v)+sqr(b)));
      putpixel(k,i+240,
               col*((trunc((a+1020)/300)+trunc((s+10000)/300)) mod 2)) ;
    end;

  tt:=trunc(sr/sc*720);
  sch:=0;
  for ops:=1 to 200 do begin
    sv:=sv+20;sc:=sc-0;
    tt:=trunc(sr/sc*720);

    getimage(trunc(sv/sc*720)+259-tt,
             239+trunc((240-sb)/sc*720)-tt,
             trunc(sv/sc*720)+261+tt,241+trunc((240-sb)/sc*720)+tt,q[1]);
    for i:=-tt to tt do
      for k:=-tt to tt do begin
        if (i*i+k*k)<tt*tt then begin
          sd:=-sqrt(tt*tt-i*i-k*k);
          ic:=sd-sc;
          iv:=-i-sv;
          ib:=500-k-sb;
          vc:=-((sd-10)*sd*sd+i*i*sd+k*k*sd+sd*i*i+i*i*sd+sd*k*k+k*k*sd)/tt;
          vv:=-(-sd*i+vc*i)/sd+i;
          vb:=-(sd*k-vc*k)/sd-k;
          vc:=2*vc-(sd-10);
          vv:=2*vv-i;
          vb:=2*vb+k;
          if (k>0)and(abs(sd)>(tt/10)) then begin
            a:=trunc((sc+sd)+(sb-k)*vc/vb);s:=trunc((sv+i)-(sb-k)/vb*vv);
            col:=trunc(43*b/100/sqrt(sqr((a-c)/100)+sqr((s-v)/100)
                       +sqr(b/100)));
            putpixel(trunc(sv/sc*720)+i+260,k+240+trunc((240-sb)/sc*720),
                     10+col*((trunc((a+1020)/300)+trunc((s+10000)/300)) mod 2));
          end else begin
            iv:=(sd*(c-sc)+i*(v-sv)-k*(b-sb))/
                sqrt(sqr(c-sc)+sqr(v-sv)+sqr(b-sb))/tt;
            if iv>0.96 then col:=trunc((iv-0.96)*53/0.04)+10 else col:=10;
            putpixel(trunc(sv/sc*720)+i+260,k+240+trunc((240-sb)/sc*720),col);
          end;
        end;
      end;

      key:=readkey;
      putimage(trunc(sv/sc*720)+259-tt,239+trunc((240-sb)/sc*720)-tt,q[1],0);
      If key=#27 then break;
  end;
  readkey;
  CloseGraph;
end.




